June 10
-------
Pong Map 1.1.1
Pong Ultra 1.1.1
-----------------
+If no tileset is found, game/map will no longer crash, rather it will exit with a warning
+2 New Abstract Maps
+Finished!


May 31,2003
-----------

Pong Ultra 1.1.01
-----------------
+No maps found Bug Fix
+On Slow Computers, Screen Unable to Refresh-Fixed
+Windows Installer No longer installs to Program Files\Pong ultra\Pong Ultra Now does only Program Files\Pong Ultra\

Pong Map 1.1.1
----------------
+Map Editor Now Remembers Previously chosen Skin
+Probable Crash Fixed,when selecting tile to animate to numbers


May 22,2003
----------
No updates becuase if written no code, anyways Everythings ready to release and ive given up trying to get it to compile for msvc

Pong Ultra 1.1 is finally done!

April 29,2003
--------------
Okay, all bugs fixed, gif support now a go. Gif support, was not written by me, so i still have to write my own for practice, but it is HEAVILY modified, to the point where i removed over 50% of the code, all i really did was drop animation support though :)

April 24,2003
--------------

So heres the story, I fixed all bugs for pong game and im pretty sure for pong map too, but now dumb is acting up and causing problems, im gonna downgrade and see how it goes.


Aril 23,2003
-------------
Only a few more bug fixes to go....
And maps, otherwise done.

Pong Game ver 1.1
----------
+Fixed a few menu bugs.
+Fixed (finally) Graphics bug. Looks much nicer now.
+Got a new font (some complaints about it), and organized code to work with the new font.
+Compiled with code optimizations, and uh, i cant see a difference. Rotate sprite however is much faster.(Were talking a 100% speed increase)


Pong Map ver 1.1
-----------
+Fixed Packfile screws loaded maps.
+Heh, no more bugs as far as i know.(well, if a saved map is loaded, but images are missing = youve got problems)
+Now Compiled With Code optimizations, and let me say WOW, 50% faster.

+Ships with Allegro 4.03 DLL now

April 20,2003

Pong Game ver 1.02
----------
+Paddles were grabbed incorectly, FIXED
-AAAAARGGGGHHHHHHHH, problems. Somehow the jpg loader is starting to have problems, and i dont know how to fix it. I'll see what i can do.
+AARRRRRRGGHHHHHH I SPENT 4 &#*&#&%(#&()*#( HOURS, FOUR AND THE DAMN PROBLEM WASNT EVEN MY FAULT, PLEASE TELL ME WHY CANT A DAMN JPEG LOADER WORK WITH DRAW_MODE_TRANS ON! WHY!!!!!!!!!!!!!!!
Yeah, you guessed it. fixed.

Maps
-----
Abstract level set is done, and get this, thanks to compression, has 6 levels and is half the size of blurry! W00t! ;)


Pong Map ver 1.09
---------
+Fixed an absolute disatorous bug that prevents save_as_map from working properly
+Show 4 Player Boundaries, actually GASP works!
+Now When you chnage the ball animation stats, or map type the map editor will remember it for you, saves lots of hassles!
+I Cant think of anything else to fix, the save tile set is a whole other can of fish

April 19,2003
------------
Whats done aside from me constantly yelling at the damn gif loading code to do something (well, im at the part where i load the image, yeah, i know, thats pretty bad for 5 hours)
Well, pong setup is done, and its now ready to distribute, the games almost done now, just need one, or two , or three, or 10 more maps ;)


April 11,2003
-------------
What no new posts what was i up to?
Well the only main change is the game now uses, Dumb 0.92. Cheers!
Oh, and i finally finished the darn tutorial. Yay!

March 29,2003
--------------

Pong Game ver 1.02
------------------
+New High Colour Fade routines DONE!
+Frame rate increase, about 10%, Not as much as hoped, but its there.
+Code hundreds times neater than previously. Unfortuneltly, its still ugly.
+Code Section of Pong Game done, only testing left!

Pong Map ver 1.082
-----------------
+Frame rate doubled :) yay!
+Only Testing left!

March 28,2003
--------------

Pong Game ver 0.94
------------------
+Song Selection Finished!
+Song Setup + Control Configuration now saved and loaded.


March 27,2003
-------------
Pong Game ver 0.93
-------------------
+Sliding Paddles Fixed, is much better(still a little choppy, but
much improved)
+6 Songs Now in game, only two more to go!

March 24,2003
-------------
Pong Map 1.09
-------------
+Save tileset fixed, ive come to the conclusion strncpy is buggy, whenever i use it i get problems.(or, maybe its not its fault that it doesnt copy the extra NULL terminator, whatever.

Pong Game ver 0.92
-------------------
+Set_Sound now disables sound, AND doesnt exit program
+allegro_message now only used for crashed
+loading info now displayed
+comments bug fixed
+set default controls available.

March 22,2003
-------------
Okay the Pong Map editor is almost done, the few bugs that go with create_tileset, will NOT be fixed for 1.1 release(well, maybe), as they are not mandatory.
The only things that may be added to Pmap are:
 +Bug Fixes
 +Have changable default skin

For future idea : Be able to save in different formats(pcx,bmp,tga etc)

Pong Game ver 0.91
------------------
+In 16bit
+Wall Collison Detection fixed
+Suports Multiple file types

Pong Map ver 1.08
------------------
+Packfile now foolproof (well, as much as it'll get)
+Tileset_Create done, some problems
  -Tileset must be divisble by 32(well, will still work with pixel loss)
  -If Filename to convert has only 3(in windows it is worse,this bug is now officially a bug, and it will be fixed) chars ("aaa".jpg will not work, simply add two more letters too name and it will work.
  -Not all formats of jpeg allowed(ones with mspaint work fine)
+Its 99% done!


March 21,2003
-------------
The map editor is now 90% done. All functionality is done,
all that remains is to fix some bugs/advanced error cheking, and kabam, im done :)
Pong Map ver 0.92
-----------------
+Can now load multiple formats:
 -JPG
 -BMP
 -TGA
 -PCX
 -LBM
+Error Cheking not so strict on user now
March 19.2003
-------------
Pong Map ver 0.9.1
-------------------
+Now in 16bit colour
+Working on Improving compatibility and features
-Palette Skin Changing Removed
+Ships with 4 skins now, yay!
+Fixed Select Tile Bug
-All text is now blue, as opposed to white

March 18,2003
-------------
Its official. ver 1.0 is done.
Well not really, im releasing it as ver 0.9, and there are a few things 
that still need to be done, but heres why its not version 1.0:
Its uses palettes, version 1.1 will not. To Avoid confusion, version 1.0 should not use palettes

Also the code is only really 99% complete and a little buggy becuase:
The art and Music is not done yet. So a little code will need to be modified. But not much.

And the work done

Pong Game ver 0.9
-----------------
+Palette Bug fixed

Whats next? Well lots of changes to the source will be made, lots of improvements and bugs fixed, new features, and 16/15 bit colour, + a new version of dumb will be installed.

March 17,2003
--------------
Lets see, whats new, first of for both pong map and pong game i present:

Rotate Sprite Ver 2.0
---------------------
+Originally Written By Rel
+Ported By Hard Rock
+Optimized By Zcot, now runs 3x faster! Thanks man!
Thats right, a 3x speed increase in this routine, its a hell of a lot faster now.

Now onto game stuff
Pong Map ver .8.2
------------------
+Uses new Rotate sprite

Pong Game ver .7.9
-----------------
+Uses new rotate sprite
+Scoring Modes now completed.


March 15,2003
--------------
The End is Near! For version 1.0 anyways, i figure one more week of coding or so and the code bit will be done. Then its onto 1.1

Pong Game ver .7.7
-------------------
+Scoring For Solo/For Score Modes Done
+High Scores are saved
+Fixed Menu Display Bug
+Score Type Text Now Shows
-Score Type Not Disabled When For score/game_type 1 selected

Yep A lot of works been done.

March 13,2003
-------------
Pong Game Ver .7.3
------------------
+Tournament Mode Done, Feels like a waste of time
though, since i dont think i did it right, oh well
to late now :(
March 12,2003
-------------
Pong Game Ver .7.2
------------------
+Bug fix, in change controls, music now plays.
+Pong Game can now save npk's (for internal use)
+Text Of Game Mode Now changes


March 11,2003
-------------
Not quite as much work today, but some very important work netherles.

Pong Map Ver .8.2
------------------
+Fixed Near Fatal Save .npk routine(well it wasnt fatal at all, it just didnt save)
+Shrunk comments to 150 characters, still plenty.

Pong Game Ver .7.1
-------------------
+Displays Valid Map info now
-Found bug in gmenu routine, when maps get wider, does not unwide to get smaller, while still pointing to same map. Must recalculate each blit.

March 7,2003
------------
Tons and Tons of work today, Just look at the list yourself to see what i mean.

Pong Game Ver .7.0
------------------
+Buttons Can Now be Changed
-No Button Error Checking
+Joystick Support
-Only 1 Joystick
+Menu Is now Centered
+New Message Code
-Message Code Is Very Beta
+User Type Now effects Game stuff
+Solo Mode Implented
-Solo Mode Very Beta


February 28,2003
-----------------
Well last update of february, i have been working these last six days, even if not on very important issues.

Pong Game ver .6.5
-------------------
+Music Can be Turned Off
+Sound Can be Turned Off
+Sound and Music Volume is settable from Loud, Medium and Quiet.
+Sounds are done.

Apparentlly My Map editor is misnamed, it should be at:

Pong Map Editor ver .8.1

February 22,2003
----------------
If i keep adding .0.1 to every update i do, soon ill be up at 1.00 and not finished ;)

Pong Game ver .6.4
-------------------
+Song Setup Finally done, songs can be disbalbed, enabled, and chosen. 
-Preferences are not saved as of yet.

February 21,2003
----------------

Pong Game ver .6.3
-------------------
+First Build of Hard Dificulty, works beautifuly on the sides,
not so well on the top and bottom. Thanks goes to ITM for making his game open source so i could figure out how to code it in.


February 19,2003
----------------

Pong Game ver .6.2
-------------------
+Random Numbers Fixed
+Normal Difficulty Done(sucks a little)
+Fixed Screwy Collisons.




Pong Game ver .6.1
-------------------
-Physics still very very "rocky" almost like hitting bricks, dont know if will fix
+5 Songs gathered so far, only 3 more to go


February 15,2003
-----------------
Pong Game ver .6.1
------------------
+Improved Physics, They Still suck a bit though
-Think about changing ball gets faster over time, to limit gets higher all the time, makes more game sense.(physics idea)


February 11,2003
----------------
Problems, I wont say much basically i would be busy starting now,
but not this busy, meaning, yep you guesed it

DELAYS!


February 10,2003
---------------
I was supposed to do a whole new game mode, instead got lazy, and only a small update

Pong Game ver .6.1
------------------
+User/Player Options disbaled if need be

Wait hang on, just updated Map Editor

Pong Map ver .8
----------------
+Stability Finally Fixed
Only need to implent following
-Support For new Game Mode
-Press Escape For menu
-Update Create Packfile for tournament mode support
+Create Tileset at ver 1.0

February 7,2003
---------------
Tons and Tons of new work, well not with the map editor,
but ive put a lot of work in the game

Pong Game ver .6.0
-------------------
+Menu Now Works, and is used a lot more
+Ball Respawn Fixed
+Paddle Ai Can now go after multiple balls, but needs work still
+New Font
+Meny Can Cycle Through all available packfiles
+Number of balls can be changed
+Lots more useless stuff ive forgotten


February 2,2003
----------------
This is got to be one of the first times ive done backtoback work!

Pong Map ver .6.1 and Pong Game ver.5.6
---------------------------------------
+New rotate sprite done! and optimized! Oh yeah! 
  Tiles can now rotate

February 1,2003
-----------------
Eeek, Just noticed i had 2002 instead of 2003 everywhere. Fixed.

Lots and Lots of Work Done

Pong Map ver .6
-----------------
+NPK Format Finalized
+Its finally called .6!

And the most work was done here:

Pong Game ver .5.5
------------------
+Menu System Done
  +D_BACK works fine
  +Has Global Colour Ints
  +Calc H+W of fonts and use it
  +Does not Display D_HIDDEN
  +Trans/Solid Backround Options
  +Works with various fonts
  +Draw_Menu and Update_Menu are seperate
  +Works like allegros menu, uses a polling system
+Finished Updating Music.c/h
+Works with new .npk format..

+Menus
  +Main Menu Done(Play, Options,Credits,Exit)

Now ive only got 2 weeks left to work

January 16,2003
----------------
Ive Been Really lazy once again

Pong Game ver 4.6
------------------
+Can automaticly detect all new packfiles in .map directory
-I may have to modify the npk format. Shoot.

January 11,2003
----------------

Pong Game ver 4.4
------------------
+Support For multiple balls added(2)
-Ai cant distinguis between balls
-Need Support For up to 4 Balls.

January 10,2003
----------------
Hmm, I still keep forgetting to update this log.
Well,

Pong Map ver .5.9
-----------------
+Finaliazed Map Format

Pong Game ver .4.3
-------------------
+Updated Sprite Struct
+Ball Can Now Animate

Saturday December 23,2002
-------------------------
Pong Game ver .4
----------------
Wont Record All My Additions, instead
Ive finished Pong Christmas Edition

Pong Map ver 5.6
-----------------
+Included a create tileset option, which takes a 
ordinary pic and converts it.

Saturday December 8,2002
------------------------
Pong Game ver .3
----------------
+Packfile Levels Now Choosable
+4 Player Works
-Menu is as ugly as hell

Christmas Additions
-------------------
+Christmassy font
-It isnt red and green yet, ill do that real soon.


Saturday December 7,2002
------------------------
I spent an hour trying to find my dos to map editor port problem, 
I tore my code apart and by the time i found the bug, my code was unusable. Lucky i found a backup and i fixes it,

The bug that windows didn't like was:
strcpy(string,NULL);
doesnt work under windows. WTF? Anyways i fixed it doing:
sprintf(string "%d",0);
Still the first one should work. And that took me an hour to find.
Arghhhhhhhhh.


Friday November 29,2002
-----------------------
Pong Map Ver .5.5
-----------------
-Bug where close_map is shown when a map isnt
-Bug where GUI_SHOW is included, ignore this
+Save_as map included
-Must Switch From using draw_sprite to blit to draw the backround
-4 Player set boundaries are "f******" Must set to 1 tile
-Pmap crashes when choosing tiles animation settings
Fire Demo to be included in demo is done(build 1 at least), it still needs a hell of a lot of work though.

Saturday November 23,2002
-------------------------
Pong Map Ver .5
---------------
+A little Bit more error checking has been added
-Most new functions have 0 error checking
+Map Format Is Done.
+PackFile Format Is Done.
*A few more additions will happen, but both have been designed to
support additions, bare bone format however is done.
-Have Yet To implent New Map Format In Map Editor.
+Map Editor is 50% Done!


Thursday November 21, 2002
--------------------------
A little mistake, it seems sys to virtual memory does not work for some stupid reason, and it turns out hard ware acceleleatation will on boost the fps by, uh 40, I can get super speed, but that will mean having all sprites stored as video sprites, and the allegro docs mentioned there were some problems with overlapping video memory, so uh it goes from 240 to 300.

Wednesday November 20, 2002
---------------------------
I've found a cure! Well, i blocked myself from the internet and i coded! And whenever i felt like going on it, i didnt. And i got some work done. Yep, now ill go a week or so like this and see how far along in game dev i get.

Thursday November 14, 2002
--------------------------
Allright, i havn't coded in an entire week, i don't know why, but i
just didnt feel like coding for that whole time. Now i feel a little better and managed to get a little code done, ive done Pong Map Editor .4.2, it features:

Pong Map Editor Ver .4.2
------------------------
+Packfiles now put all map stuff inside them
+Balls + Paddles are now supported And skinned
+4 Player mode editable and saveable now(not yet programmed playable however)
+Animation and Rotating bitmaps now selectable
-Bug where dialogs get disorted (eg words get mixed up from seperate dialogs, not sure why this is happening, never worked with pointers before this game)
+Probably a few more unnoticable differences and additions




Tuesday 5/11
------------
Tiles can now animate

Monday 28/10
-------------
Packfiles can now support more than one map at a time(yay)
But is currently turned off for safety reasons......(error checking is insufficien)
And the same map can be added twice to a packfile for some real stupid reson...........

Notes to self:
--------------
+Have it so that sprite_grab can be told the x and y co-ordinates to
start grabbing..........
+paddle [1] should be blit _vflipped so faces center
+ball should have animation???
+Fonts can be used, but i find it a bit stupid that i have to make a datafile to use them
Pong Ver .2.5
-------------
+Can Use Skins now


Pong Version .2
----------------------
+Can load Packfile ver.1
-Cant clean up after self yet
+Divided into modules


Pong Map Editor Ver .3.5
------------------------
-Packfile Format is .map file + backround .bmp.(Packfile ver.1)
-Balls +Paddles not yet supported
+Keyboard Shortcut for exit added
+Dialogs Cleaned Up
+Create Packfile Ver.1
+Extract Packfile Ver.1(Dev Team Member Feature Only)
+Can Add Skins to Packfile(Ver.1.1)


Pong Map Editor Ver.3
---------------------
Bugs:
Find some and tell me about them

This was done really fast(4 days) and offers some nice improvements over it's predescer. Save_file still NOT compatible.

+fixed close_map bug(it was really stupid)
+load map no longer iffy
+added in alert buttons
+gui colours now changable(yay!)
+speed increase(map editor now runs 60fps faster)
+updated About dialog
+upx will be used on dos executable(dont need it on windows... yet) to shrink it by 75%!





Pong Map Editor Ver .2
----------------------
Bugs:
Close Map Exits the program(odd, it works fine in dos)Will fix
Load Map Dialog Really iffy right now, needs a lot of work
Tell me any more you find

New features
+palette properly supported
+load map(iffy)
+save map(will not work with future version)
+close map(screwed up too)
+settings dialog updated
+lots of other additions.

Like i said, most things have now been overhauled, and included is the windows build. Enjoy.

Pongmap.exe is windows build
Pmap.exe is dos build




Pong Map Editor Ver .1
----------------------

Okay first of, this is VERY early in dev and not very usable yet. Two more weeks and i can have a version that you can actually use, just not yet. What it currently supports:

+Menus
+About Menu
+Edit Settings
+Exit
+Change Map tiles


Yes this is very rushed, for Ver .2 I will overhaul everything.
Including the documentation.

Also please note the windows version will not be included until ver .2

Pong Ver.001
------------
So far its only to boxes moving up + down with some real pathetic collison detection.